
#ifndef _BPF_H_
#define _BPF_H_

#include "Function.h"

/*
	нťѥ졼ȥեBPF
*/

class BPF : public Function{
public:
	//󥹥ȥ饯
	BPF(int n){
		designNum = n;
		objectiveNum = 2;
		constraintNum = 0;
		max = new double[designNum];
		min = new double[designNum];
		for(int i=0;i<designNum;i++){
			max[i] = 1.0;
			min[i] = 0.0;
		}	
	}	

	//߷ѿŪؿ֤ͤ
	void evaluate(double* design,double* f){
		double g,h,temp;
		f[0]=1.0-exp(-4.0*design[0])*pow(sin(5.0*PI*design[0]),6.0);
		temp=0.0;
		g = 1.0;
		for(int i = 1; i < designNum; i++) {
			temp += design[i];
		}
		g+=10.0*pow(temp/(designNum-1.0),0.25);
	
		if(f[0]<=g) h=1-pow(f[0]/g,2.0);
		else h=0.0;
	
		f[1]=g*h;
	}
	
	//߷ѿＰ֤ͤ
	void evaluateConstraint(double* design,double* g){
		for(int i=0;i<constraintNum;i++){
			g[i] = 0.0;
		}
	}
};
#endif
