#ifndef _KUR_H_
#define _KUR_H_
#include "Function.h"
#include <cmath>

/*
	KUR
*/

class KUR : public Function{
public:
	//󥹥ȥ饯
	KUR(int n){
		designNum = n;
		objectiveNum = 2;
		constraintNum = 0;
		max = new double[designNum];
		min = new double[designNum];
		for(int i=0;i<designNum;i++){
			max[i] = 5.0;
			min[i] = -5.0;
		}	
	}	

	//߷ѿŪؿ֤ͤ
	void evaluate(double* design,double* f){
        f[0]=0;
		for(int i = 0; i < designNum-1; i++) {
			f[0] += -10*exp(-0.2*sqrt(design[i] * design[i] + design[i+1]*design[i+1]));
		}
	
		f[1]=0;
		for(int i=0;i<designNum;i++){
			f[1] += pow(fabs(design[i]),0.8)+5*sin(design[i]*design[i]*design[i]);
		}
	}

	//߷ѿＰ֤ͤ
	void evaluateConstraint(double* design,double* g){
		for(int i=0;i<constraintNum;i++){
			g[i] = 0.0;
		}
	}
};
#endif //_KUR_H_
